
function initAppJs() {
    var appKey = "appJs";
    var app = {};
    var appMap = {};

    window.sendNativeInfo = function(name,info){
        if(navigator.userAgent.match(/Android/i)) {

            if(window[name]&& window[name].postMessage){
                    window[name].postMessage(info);
               }
                  }else{
                   if(window.webkit&&window.webkit.messageHandlers&&window.webkit.messageHandlers[name]&&window.webkit.messageHandlers[name].postMessage){
                       window.webkit.messageHandlers[name].postMessage(info);
                    }
                  }
    }
function getAsyncFunction(method,param){
    var info = {};
    info["id"] = (new Date).getTime() + Math.floor(1e3 * Math.random());
    info["method"] = method;
    info["param"] = param;
    var promiseObj = {};
    var promise = new Promise(function(resolve, reject) {
        promiseObj.resolve = resolve
          promiseObj.reject = reject
     });
    appMap[info.id] = promiseObj;
    window.sendNativeInfo(appKey, JSON.stringify(info));
     return promise;
}
window.runAsyncCallback = function runAsyncCallback(json){
     var id = json["id"];
     if (id && appMap[id]) {

          var err = json["err"];
            var rt = json["value"];
            if(err!=null){
             try {
                     err = JSON.parse(err);
                    } catch(e) {
                       err = json["err"];
                    }
            }

            var promiseObj = appMap[id];

                if (err != null) {
                    promiseObj.reject(err);
                } else {
                    promiseObj.resolve(rt);
                }

                 appMap[id] = null;
     }
}
app.getCurrentLocation = function(param){
   return getAsyncFunction("getCurrentLocation",param);
};

app.toast = function(param){
   return getAsyncFunction("toast",param);
};
app.getToken = function(param){
   return getAsyncFunction("getToken",param);
};
app.login = function(param){
   return getAsyncFunction("login",param);
};
app.backPressed = function(param){
   return getAsyncFunction("backPressed",param);
};
app.tel = function(param){
   return getAsyncFunction("tel",param);
};
app.loginOut = function(param){
   return getAsyncFunction("loginOut",param);
};
app.codeScan = function(param){
   return getAsyncFunction("codeScan",param);
};
app.mapNavigation = function(param){
   return getAsyncFunction("mapNavigation",param);
};

window.nativeApp = app;
window.app = app;

}
if (!window.nativeApp) {
    initAppJs();
}